use crate::db::{Database, DatabaseItem, DatabaseItemVisitor};
use crate::entity::{Entity, EntityVisitor};

mod entity;

pub fn collect_from_database<DB: Database>() {
    struct IV(entity::EntityStateContainer);

    impl DatabaseItemVisitor for IV {
        fn visit<DI: DatabaseItem>(&mut self)
        where
            Self: Sized,
        {
            DI::accept_entity_visitor(&mut self.0.make_context(DI::item_key()));
        }
    }

    let mut iv = IV(entity::EntityStateContainer::default());

    DB::accept_item_visitor(&mut iv);

    println!("collected base info from database: {:?}", iv.0);
}
